﻿DECLARE @@SYS_VAL VARCHAR(50);
DECLARE @@SYSDATE VARCHAR(30) = CONVERT(VARCHAR, GETDATE(), 112);
DECLARE @@SEQ INT;

IF @type = 'IPPCS'
BEGIN
	SELECT @@SYS_VAL = SYSTEM_VALUE FROM TB_M_SYSTEM where FUNCTION_ID = 'IPPCS_SEQ_FILE' AND SYSTEM_CD = 'SEQ_GR'

	SELECT ROW_NUMBER() OVER (ORDER BY (SELECT 1)) NO, ListValue 
	INTO #TB_T_LIST
	FROM fn_SPOT_ListToTables(@@SYS_VAL, ';')

	IF (@@SYSDATE = (SELECT ListValue FROM #TB_T_LIST WHERE NO = 1))
	BEGIN
		SET @@SEQ = (SELECT ListValue FROM #TB_T_LIST WHERE NO = 2) + 1;
	END ELSE 
	BEGIN
		SET @@SEQ = 1;
	END

	UPDATE A
	SET A.SYSTEM_VALUE = @@SYSDATE + ';' + CONVERT(VARCHAR, @@SEQ)
	FROM TB_M_SYSTEM A
	WHERE FUNCTION_ID = 'IPPCS_SEQ_FILE' AND SYSTEM_CD = 'SEQ_GR'

	SELECT 'GR_IPPCS_' + @@SYSDATE + RIGHT('0000' + CONVERT(VARCHAR(4), @@SEQ), 4) SeqNo

	DROP TABLE #TB_T_LIST
END ELSE
BEGIN
	SELECT @@SYS_VAL = SYSTEM_VALUE FROM TB_M_SYSTEM where FUNCTION_ID = 'JPO_SEQ_FILE' AND SYSTEM_CD = 'SEQ_GR'

	SELECT ROW_NUMBER() OVER (ORDER BY (SELECT 1)) NO, ListValue 
	INTO #TB_T_LIST2
	FROM fn_SPOT_ListToTables(@@SYS_VAL, ';')

	IF (@@SYSDATE = (SELECT ListValue FROM #TB_T_LIST2 WHERE NO = 1))
	BEGIN
		SET @@SEQ = (SELECT ListValue FROM #TB_T_LIST2 WHERE NO = 2) + 1;
	END ELSE 
	BEGIN
		SET @@SEQ = 1;
	END

	UPDATE A
	SET A.SYSTEM_VALUE = @@SYSDATE + ';' + CONVERT(VARCHAR, @@SEQ)
	FROM TB_M_SYSTEM A
	WHERE FUNCTION_ID = 'JPO_SEQ_FILE' AND SYSTEM_CD = 'SEQ_GR'

	SELECT 'GR_JPO_' + @@SYSDATE + RIGHT('0000' + CONVERT(VARCHAR(4), @@SEQ), 4) SeqNo

	DROP TABLE #TB_T_LIST2
END